#include "ffdb.h"
#include <stdio.h>

int main(void) {
	//build descriptor
	RowSetDescriptor tmp_desc;
	tmp_desc.push_back(ColumnDescriptor(ColumnType_integer,"id"));
	tmp_desc.push_back(ColumnDescriptor(ColumnType_string,"username"));
	tmp_desc.push_back(ColumnDescriptor(ColumnType_raw,"password"));
	
	//Create rowset with descriptor
	RowSet rowset_user;
	rowset_user.setDescriptor(tmp_desc);
	
	//Create a row
	Row tmp_row;
	int64_t id = 17;
	tmp_row.alloc(sizeof(id),sizeof(id),&id);
	const char username[]="johnny";
	tmp_row.alloc(sizeof(username),1,username);
	const char password[]="secret";
	tmp_row.alloc(6,1,password);
	
	//Add the row to the rowset
	rowset_user.push_back(tmp_row);
	
	//And get it again
	RowSet::const_iterator iter=rowset_user.begin();
	int64_t fetched_id = *(const int64_t*)((*iter)[0].ptr);
	
	return 0;
}
