//Example program demonstrating the PreparedSelection class
//There is no Selection() function (too unsafe)
#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_op.h"
#include "ffdb_util.h"
#include <stdio.h>

int main(void) {
	RowSet rowset_user;
	if(!ReadFromFile("example_db_user.ffdb",&rowset_user)) {
		fprintf(stderr,"Could not read from user database\n");
		return -1;
	}
	
	PreparedSelection prep_sel;
	int cond_idx = prep_sel.add_condition("username",cond_eq);
	prep_sel.set_value(cond_idx,"johnny");
	
	RowSet result;
	if(!prep_sel.execute(rowset_user,&result)) {
		fprintf(stderr,"Could not select from user database\n");
		return -1;
	}
	
	dump(result,stdout);
	
	return 0;
}
