#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_op.h"
#include <stdio.h>

int main(int argc, char **argv) {
	if(argc!=2) {
		fprintf(stderr,"usage error\n");
		return -1;
	}
	RowSet source_rowset;
	if(!ReadFromFile(argv[1],&source_rowset)) {
		printf("Could not load DB\n");
		return -1;
	}
	
	PreparedUnique prep_unique;
	for(int i=3; i<argc; i++)
		prep_unique.add_column(argv[i]);
	
	for(int i=0; i<5; i++) {
		RowSet result_rowset;
		if(!prep_unique.execute(source_rowset,&result_rowset)) {
			fprintf(stderr,"Unique error\n");
			return -1;
		}
	}
	return 0;
}
